// includes
#include <stdio.h>
#include <allegro.h>
// defines
#define WIDTH 320
#define HEIGHT 240

// variables are declared here
//bitmaps we will use
BITMAP *buffer,*player_bmp[2],*victim_bmp[2],*bg;
volatile int tim;
int player_x,player_y,player_frame,player_frame_counter;
int victim_x,victim_y,victim_frame,victim_frame_counter;
int victim_xv,victim_yv,victim_step_counter;
// this function will draw stuff on screen

// this function will check if distance between [x1,y1] and [x2,y2] is less than dist
int distance(int x1,int y1,int x2,int y2,int dist)
{
 int xx,yy,d;
 xx=x2-x1; // x distance
 yy=y2-y1; // y distance
 d=xx*xx+yy*yy;
 if (d>(dist*dist)) return 0; else return 1;
}

void bleed(BITMAP *bmp,int howmuch)
{
  int c,x,y;
  // it will make howmuch blood spots on the bmp bitmap
  for (c=0;c<howmuch;c++)
  {
    x=rand()%bmp->w; // randomize point on bitmap
    y=rand()%bmp->h;
    // if pixel at x,y is not magic pink it will put a randomnly red dot there
    if (getpixel(bmp,x,y)!=makecol(255,0,255)) putpixel(bmp,x,y,makecol(128+(rand()%127),0,0));
  }
}

void mess(BITMAP *bmp,int x,int y)
{
  int r;
  r= 4+(rand()%4);
  ellipsefill(bmp,x+(rand()%64),y+(rand()%64),r,r/2,makecol(128+(rand()%127),0,0));
}

void draw()
{
  stretch_blit(bg,buffer,0,0,bg->w,bg->h,0,0,WIDTH,HEIGHT);
  // draw player bitmap at its position
  draw_sprite(buffer,victim_bmp[victim_frame],victim_x-(victim_bmp[victim_frame]->w/2),victim_y-(victim_bmp[victim_frame]->h/2));
  draw_sprite(buffer,player_bmp[player_frame],player_x-(player_bmp[player_frame]->w/2),player_y-(player_bmp[player_frame]->h/2));
}


// this function will be timed and update our variables
void timer_proc()
{
  if (key[KEY_UP] && player_y>0)        {player_y--;player_frame_counter++;}
  if (key[KEY_DOWN] && player_y<HEIGHT) {player_y++;player_frame_counter++;}
  if (key[KEY_LEFT] && player_x>0)      {player_x--;player_frame_counter++;}
  if (key[KEY_RIGHT] && player_x<WIDTH) {player_x++;player_frame_counter++;}
  player_frame=1 & (player_frame_counter>>4); //change the frame

  victim_frame_counter++;
  victim_frame=1 & (victim_frame_counter>>3); //change the frame
  if (victim_step_counter)
  {
    victim_x+=victim_xv;
    victim_y+=victim_yv;
    if (victim_x<0 || victim_x>WIDTH) {victim_xv*=-1;victim_step_counter+=10;}
    if (victim_y<0 || victim_y>HEIGHT) {victim_yv*=-1;victim_step_counter+=10;}
    victim_step_counter--;
  } else {
    victim_xv=3-(rand()%7);
    victim_yv=3-(rand()%7);
    victim_step_counter=20+(rand()%20);
  }
  if (distance(player_x,player_y,victim_x,victim_y,32))
  {
    bleed(victim_bmp[0],20);
    bleed(victim_bmp[1],20);
    mess(bg,victim_x-(victim_bmp[0]->w/2),victim_y-(victim_bmp[0]->h/2));
  }
}

// this function will load stuff and set up variable initial values
void load_stuffs()
{
  player_bmp[0] = load_bmp("player.bmp",NULL); // load player bitmap
  player_bmp[1] = load_bmp("player2.bmp",NULL); // bitmap second frame
  player_x=80; // set initial position
  player_y=60;
  player_frame=0; // set current frame to 0
  player_frame_counter=0;

  victim_bmp[0] = load_bmp("victim.bmp",NULL); // load victim bitmap
  victim_bmp[1] = load_bmp("victim2.bmp",NULL); // bitmap second frame
  victim_x=240; // set initial position
  victim_y=180;
  victim_frame=0; // set current frame to 0
  victim_frame_counter=0;
  victim_step_counter=0;
  bg = load_bmp("street.bmp",NULL);
}

// this is timer interrupt, DO NOT TOUCH THIS
void timer()
{
	tim++;
}
END_OF_FUNCTION(timer);

int main(int argc, char *argv[])
{

	  allegro_init();  // Initialise allegro lib
    install_keyboard();  // install keyboard functionality
    install_timer(); // install timer functionality
    install_mouse(); // install mouse driver
    install_sound(DIGI_AUTODETECT, MIDI_NONE, argv[0]); // install sound driver
    set_color_depth(32); // set colour depth to 32-bit
    set_gfx_mode(GFX_AUTODETECT_WINDOWED, 640, 480, 0, 0); // open 640x480 window

    srand(time(NULL));

    buffer = create_bitmap(WIDTH, HEIGHT);

    load_stuffs();

    install_int_ex(timer, BPS_TO_TIMER(60));
    LOCK_FUNCTION(timer);
    LOCK_VARIABLE(tim);


    while(!key[KEY_ESC])  // this all will repeat until esc is pressed
    {
      clear_to_color(buffer, makecol(255, 255, 255)); // clears screen

      while (tim > 0)  // this here will happen only limited time a second
      {                // it will also make up for lost cycles
	      timer_proc();
	      tim--;
  	  }

      draw();
      stretch_blit(buffer,screen,0,0,WIDTH,HEIGHT,0,0,SCREEN_W,SCREEN_H);
        // this last function copies our buffer to the screen
    }

    // the finishment
    remove_timer();
    remove_sound();
    allegro_exit();
    return 0;
}
END_OF_MAIN();

